Index: branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/CodeExpressionTests.cs
===================================================================
--- branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/CodeExpressionTests.cs	(revision 14397)
+++ branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Tests/Interpreter/Expressions/CodeExpressionTests.cs	(revision 14398)
@@ -16,8 +16,11 @@
         public CodeExpressionTests()
         {
-            this.cg = new CodeGenerator(interpreter);
-        }
-
-        [TestMethod]
+            cg = new CodeGenerator(interpreter);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestAppendLists()
         {
@@ -30,8 +33,11 @@
 
             Assert.AreEqual(result, interpreter.CodeStack.Top);
-            this.CheckOtherStacksAreEmpty();
-        }
-
-        [TestMethod]
+            CheckOtherStacksAreEmpty();
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestAppendListAndLiteral()
         {
@@ -44,8 +50,11 @@
 
             Assert.AreEqual(result, interpreter.CodeStack.Top);
-            this.CheckOtherStacksAreEmpty();
-        }
-
-        [TestMethod]
+            CheckOtherStacksAreEmpty();
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestAppendLiterals()
         {
@@ -58,8 +67,11 @@
 
             Assert.AreEqual(result, interpreter.CodeStack.Top);
-            this.CheckOtherStacksAreEmpty();
-        }
-
-        [TestMethod]
+            CheckOtherStacksAreEmpty();
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestAtomList()
         {
@@ -70,8 +82,11 @@
 
             Assert.AreEqual(false, interpreter.BooleanStack.Top);
-            this.TestStackCounts(booleanStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(booleanStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestAtomLiteral()
         {
@@ -82,8 +97,11 @@
 
             Assert.AreEqual(true, interpreter.BooleanStack.Top);
-            this.TestStackCounts(booleanStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(booleanStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestAtomSingleInstruction()
         {
@@ -94,8 +112,11 @@
 
             Assert.AreEqual(true, interpreter.BooleanStack.Top);
-            this.TestStackCounts(booleanStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(booleanStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestCarList()
         {
@@ -107,8 +128,11 @@
 
             Assert.AreEqual(result, interpreter.CodeStack.Top);
-            this.CheckOtherStacksAreEmpty();
-        }
-
-        [TestMethod]
+            CheckOtherStacksAreEmpty();
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestCarNoList()
         {
@@ -120,8 +144,11 @@
 
             Assert.AreEqual(result, interpreter.CodeStack.Top);
-            this.CheckOtherStacksAreEmpty();
-        }
-
-        [TestMethod]
+            CheckOtherStacksAreEmpty();
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestCdrList()
         {
@@ -133,8 +160,11 @@
 
             Assert.AreEqual(result, interpreter.CodeStack.Top);
-            this.CheckOtherStacksAreEmpty();
-        }
-
-        [TestMethod]
+            CheckOtherStacksAreEmpty();
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestCdrNoList()
         {
@@ -146,8 +176,11 @@
 
             Assert.AreEqual(result, interpreter.CodeStack.Top);
-            this.CheckOtherStacksAreEmpty();
-        }
-
-        [TestMethod]
+            CheckOtherStacksAreEmpty();
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestCons()
         {
@@ -160,8 +193,11 @@
 
             Assert.AreEqual(result, interpreter.CodeStack.Top);
-            this.CheckOtherStacksAreEmpty();
-        }
-
-        [TestMethod]
+            CheckOtherStacksAreEmpty();
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestContainsTrue()
         {
@@ -173,8 +209,11 @@
 
             Assert.AreEqual(true, interpreter.BooleanStack.Top);
-            this.TestStackCounts(booleanStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(booleanStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestContainsFalse()
         {
@@ -186,8 +225,11 @@
 
             Assert.AreEqual(false, interpreter.BooleanStack.Top);
-            this.TestStackCounts(booleanStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(booleanStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestContainer()
         {
@@ -200,8 +242,11 @@
 
             Assert.AreEqual(result, interpreter.CodeStack.Top);
-            this.CheckOtherStacksAreEmpty();
-        }
-
-        [TestMethod]
+            CheckOtherStacksAreEmpty();
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestDefinition()
         {
@@ -214,8 +259,11 @@
 
             Assert.AreEqual(code, interpreter.CodeStack.Top);
-            this.CheckOtherStacksAreEmpty();
-        }
-
-        [TestMethod]
+            CheckOtherStacksAreEmpty();
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestDefinitionWithoutMatchingName()
         {
@@ -227,8 +275,11 @@
             interpreter.Interpret(program);
 
-            this.TestStackCounts(nameStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(nameStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestDiscrepancy()
         {
@@ -240,8 +291,11 @@
 
             Assert.AreEqual(2, interpreter.IntegerStack.Top);
-            this.TestStackCounts(integerStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(integerStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestDiscrepancyAllEqual()
         {
@@ -253,8 +307,11 @@
 
             Assert.AreEqual(0, interpreter.IntegerStack.Top);
-            this.TestStackCounts(integerStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(integerStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestDiscrepancyComplex()
         {
@@ -266,8 +323,11 @@
 
             Assert.AreEqual(3, interpreter.IntegerStack.Top);
-            this.TestStackCounts(integerStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(integerStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestDiscrepancWithLists()
         {
@@ -279,8 +339,11 @@
 
             Assert.AreEqual(5, interpreter.IntegerStack.Top);
-            this.TestStackCounts(integerStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(integerStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestDo()
         {
@@ -291,8 +354,11 @@
 
             Assert.AreEqual(10, interpreter.IntegerStack.Top);
-            this.TestStackCounts(integerStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(integerStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestDoX()
         {
@@ -303,8 +369,11 @@
 
             Assert.AreEqual(10, interpreter.IntegerStack.Top);
-            this.TestStackCounts(integerStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(integerStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestDoCount()
         {
@@ -316,8 +385,11 @@
 
             Assert.AreEqual(6, interpreter.IntegerStack.Top);
-            this.TestStackCounts(integerStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(integerStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestDoCountWithNegativeCounter()
         {
@@ -329,8 +401,11 @@
 
             Assert.AreEqual(-1, interpreter.IntegerStack.Top);
-            this.TestStackCounts(codeStack: 1, integerStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(codeStack: 1, integerStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestDoRange()
         {
@@ -342,8 +417,11 @@
 
             Assert.AreEqual(12, interpreter.IntegerStack.Top);
-            this.TestStackCounts(integerStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(integerStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestDoRangeWithEqualIndecators()
         {
@@ -355,8 +433,11 @@
 
             Assert.AreEqual(3, interpreter.IntegerStack.Top);
-            this.TestStackCounts(codeStack: 1, integerStack: 2);
-        }
-
-        [TestMethod]
+            TestStackCounts(codeStack: 1, integerStack: 2);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestDoRangeWithNegativeIndecators()
         {
@@ -368,8 +449,11 @@
 
             Assert.AreEqual(-12, interpreter.IntegerStack.Top);
-            this.TestStackCounts(integerStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(integerStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestDoTimes()
         {
@@ -381,8 +465,11 @@
 
             Assert.AreEqual(32, interpreter.IntegerStack.Top);
-            this.TestStackCounts(integerStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(integerStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestDoTimesWithNegativeCounter()
         {
@@ -394,8 +481,11 @@
 
             Assert.AreEqual(-3, interpreter.IntegerStack.Top);
-            this.TestStackCounts(codeStack: 1, integerStack: 2);
-        }
-
-        [TestMethod]
+            TestStackCounts(codeStack: 1, integerStack: 2);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestNestedDoRange()
         {
@@ -403,8 +493,11 @@
 
             Assert.AreEqual(144, interpreter.IntegerStack.Top);
-            this.TestStackCounts(integerStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(integerStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestNestedDoCount()
         {
@@ -412,8 +505,11 @@
 
             Assert.AreEqual(144, interpreter.IntegerStack.Top);
-            this.TestStackCounts(integerStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(integerStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestNestedDoTimes()
         {
@@ -421,8 +517,11 @@
 
             Assert.AreEqual(128, interpreter.IntegerStack.Top);
-            this.TestStackCounts(integerStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(integerStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestExtract()
         {
@@ -435,8 +534,11 @@
 
             Assert.AreEqual(result, interpreter.CodeStack.Top);
-            this.CheckOtherStacksAreEmpty();
-        }
-
-        [TestMethod]
+            CheckOtherStacksAreEmpty();
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestExtractInteger()
         {
@@ -449,8 +551,11 @@
 
             Assert.AreEqual(result, interpreter.CodeStack.Top);
-            this.CheckOtherStacksAreEmpty();
-        }
-
-        [TestMethod]
+            CheckOtherStacksAreEmpty();
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestExtractFloat()
         {
@@ -463,8 +568,11 @@
 
             Assert.AreEqual(result, interpreter.CodeStack.Top);
-            this.CheckOtherStacksAreEmpty();
-        }
-
-        [TestMethod]
+            CheckOtherStacksAreEmpty();
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestExtractBoolean()
         {
@@ -477,8 +585,11 @@
 
             Assert.AreEqual(result, interpreter.CodeStack.Top);
-            this.CheckOtherStacksAreEmpty();
-        }
-
-        [TestMethod]
+            CheckOtherStacksAreEmpty();
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestExtractInstruction()
         {
@@ -491,8 +602,11 @@
 
             Assert.AreEqual(result, interpreter.CodeStack.Top);
-            this.CheckOtherStacksAreEmpty();
-        }
-
-        [TestMethod]
+            CheckOtherStacksAreEmpty();
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestFromBoolean()
         {
@@ -502,8 +616,11 @@
 
             Assert.AreEqual(result, interpreter.CodeStack.Top);
-            this.CheckOtherStacksAreEmpty();
-        }
-
-        [TestMethod]
+            CheckOtherStacksAreEmpty();
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestFromFloat()
         {
@@ -513,8 +630,11 @@
 
             Assert.AreEqual(result, interpreter.CodeStack.Top);
-            this.CheckOtherStacksAreEmpty();
-        }
-
-        [TestMethod]
+            CheckOtherStacksAreEmpty();
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestFromInteger()
         {
@@ -524,8 +644,11 @@
 
             Assert.AreEqual(result, interpreter.CodeStack.Top);
-            this.CheckOtherStacksAreEmpty();
-        }
-
-        [TestMethod]
+            CheckOtherStacksAreEmpty();
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestFromName()
         {
@@ -535,8 +658,11 @@
 
             Assert.AreEqual(result, interpreter.CodeStack.Top);
-            this.CheckOtherStacksAreEmpty();
-        }
-
-        [TestMethod]
+            CheckOtherStacksAreEmpty();
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestIfTrue()
         {
@@ -549,8 +675,11 @@
 
             Assert.AreEqual("WAHR", interpreter.NameStack.Top);
-            this.TestStackCounts(nameStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(nameStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestIfFalse()
         {
@@ -563,8 +692,11 @@
 
             Assert.AreEqual("FALSCH", interpreter.NameStack.Top);
-            this.TestStackCounts(nameStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(nameStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestInsert()
         {
@@ -578,8 +710,11 @@
 
             Assert.AreEqual(result, interpreter.CodeStack.Top);
-            this.CheckOtherStacksAreEmpty();
-        }
-
-        [TestMethod]
+            CheckOtherStacksAreEmpty();
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestInsertWithNegativeN()
         {
@@ -593,8 +728,11 @@
 
             Assert.AreEqual(result, interpreter.CodeStack.Top);
-            this.CheckOtherStacksAreEmpty();
-        }
-
-        [TestMethod]
+            CheckOtherStacksAreEmpty();
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestInsertWithTooBigN()
         {
@@ -608,8 +746,11 @@
 
             Assert.AreEqual(result, interpreter.CodeStack.Top);
-            this.CheckOtherStacksAreEmpty();
-        }
-
-        [TestMethod]
+            CheckOtherStacksAreEmpty();
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestList()
         {
@@ -622,8 +763,11 @@
 
             Assert.AreEqual(result, interpreter.CodeStack.Top);
-            this.CheckOtherStacksAreEmpty();
-        }
-
-        [TestMethod]
+            CheckOtherStacksAreEmpty();
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestMemberTrue()
         {
@@ -635,8 +779,11 @@
 
             Assert.AreEqual(true, interpreter.BooleanStack.Top);
-            this.TestStackCounts(booleanStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(booleanStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestMemberFalse()
         {
@@ -648,8 +795,11 @@
 
             Assert.AreEqual(false, interpreter.BooleanStack.Top);
-            this.TestStackCounts(booleanStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(booleanStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestMemberIfNoList()
         {
@@ -661,16 +811,22 @@
 
             Assert.AreEqual(true, interpreter.BooleanStack.Top);
-            this.TestStackCounts(booleanStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(booleanStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestNoop()
         {
             interpreter.Interpret(new CodeNoopExpression());
 
-            this.CheckOtherStacksAreEmpty();
-        }
-
-        [TestMethod]
+            CheckOtherStacksAreEmpty();
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestNthIfNoList()
         {
@@ -683,8 +839,11 @@
 
             Assert.AreEqual(result, interpreter.CodeStack.Top);
-            this.CheckOtherStacksAreEmpty();
-        }
-
-        [TestMethod]
+            CheckOtherStacksAreEmpty();
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestNthIfEmpty()
         {
@@ -697,8 +856,11 @@
 
             Assert.AreEqual(result, interpreter.CodeStack.Top);
-            this.CheckOtherStacksAreEmpty();
-        }
-
-        [TestMethod]
+            CheckOtherStacksAreEmpty();
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestNth()
         {
@@ -711,8 +873,11 @@
 
             Assert.AreEqual(result, interpreter.CodeStack.Top);
-            this.CheckOtherStacksAreEmpty();
-        }
-
-        [TestMethod]
+            CheckOtherStacksAreEmpty();
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestNthWithTooBigN()
         {
@@ -725,8 +890,11 @@
 
             Assert.AreEqual(result, interpreter.CodeStack.Top);
-            this.CheckOtherStacksAreEmpty();
-        }
-
-        [TestMethod]
+            CheckOtherStacksAreEmpty();
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestNthWithNegativeN()
         {
@@ -739,8 +907,11 @@
 
             Assert.AreEqual(result, interpreter.CodeStack.Top);
-            this.CheckOtherStacksAreEmpty();
-        }
-
-        [TestMethod]
+            CheckOtherStacksAreEmpty();
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestNthCdr()
         {
@@ -753,8 +924,11 @@
 
             Assert.AreEqual(result, interpreter.CodeStack.Top);
-            this.CheckOtherStacksAreEmpty();
-        }
-
-        [TestMethod]
+            CheckOtherStacksAreEmpty();
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestNthCdrWithTooBigN()
         {
@@ -767,8 +941,11 @@
 
             Assert.AreEqual(result, interpreter.CodeStack.Top);
-            this.CheckOtherStacksAreEmpty();
-        }
-
-        [TestMethod]
+            CheckOtherStacksAreEmpty();
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestNthCdrWithNegativeN()
         {
@@ -781,8 +958,11 @@
 
             Assert.AreEqual(result, interpreter.CodeStack.Top);
-            this.CheckOtherStacksAreEmpty();
-        }
-
-        [TestMethod]
+            CheckOtherStacksAreEmpty();
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestNthCdrIfEmpty()
         {
@@ -795,8 +975,11 @@
 
             Assert.AreEqual(result, interpreter.CodeStack.Top);
-            this.CheckOtherStacksAreEmpty();
-        }
-
-        [TestMethod]
+            CheckOtherStacksAreEmpty();
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestNthCdrIfNoList()
         {
@@ -809,8 +992,11 @@
 
             Assert.AreEqual(result, interpreter.CodeStack.Top);
-            this.CheckOtherStacksAreEmpty();
-        }
-
-        [TestMethod]
+            CheckOtherStacksAreEmpty();
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestNullTrue()
         {
@@ -821,8 +1007,11 @@
 
             Assert.AreEqual(true, interpreter.BooleanStack.Top);
-            this.TestStackCounts(booleanStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(booleanStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestNullFalse()
         {
@@ -833,8 +1022,11 @@
 
             Assert.AreEqual(false, interpreter.BooleanStack.Top);
-            this.TestStackCounts(booleanStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(booleanStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestPosition()
         {
@@ -846,8 +1038,11 @@
 
             Assert.AreEqual(2, interpreter.IntegerStack.Top);
-            this.TestStackCounts(integerStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(integerStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestQuote()
         {
@@ -857,8 +1052,11 @@
 
             Assert.AreEqual(result, interpreter.CodeStack.Top);
-            this.CheckOtherStacksAreEmpty();
-        }
-
-        [TestMethod]
+            CheckOtherStacksAreEmpty();
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestSize()
         {
@@ -869,8 +1067,11 @@
 
             Assert.AreEqual(4, interpreter.IntegerStack.Top);
-            this.TestStackCounts(integerStack: 1);
-        }
-
-        [TestMethod]
+            TestStackCounts(integerStack: 1);
+        }
+
+        [TestMethod]
+        [TestProperty("Time", "Short")]
+        [TestCategory("ExpressionTest")]
+        [TestCategory("CodeExpressionTest")]
         public void TestSubstitude()
         {
@@ -884,5 +1085,5 @@
 
             Assert.AreEqual(result, interpreter.CodeStack.Top);
-            this.CheckOtherStacksAreEmpty();
+            CheckOtherStacksAreEmpty();
         }
 
@@ -910,5 +1111,5 @@
         protected override void CheckOtherStacksAreEmpty()
         {
-            this.TestStackCounts(codeStack: null);
+            TestStackCounts(codeStack: null);
         }
     }
